<ui:composition xmlns:g="http://www.ihe.net/gazelle" xmlns:gri="http://java.sun.com/jsf/composite/gri"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:rich="http://richfaces.org/rich"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:gzl="http://java.sun.com/jsf/composite/gazelle-tags"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form>
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
            <gzl:div id="globalDiv">
                <h1>FHIR Validators</h1>
                <gri:panel>
                    <f:facet name="header">
                        Available FHIR Validators
                    </f:facet>
                    #{dataTableStateHolder.setAscendingOn('name')}
                    <rich:dataTable value="#{fhirValidatorDescriptionList.getAllFhirValidatorDescriptions()}" var="val"
                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}" id="valTable" render="dsValTable">
                        <g:column >
                            <ui:define name="header">Type</ui:define>
                            <h:outputText value="#{fhirValidatorDescriptionList.getValidatorType(val)}"/>
                        </g:column>
                        <g:column filterBy="#{'oid'}" sortBy="#{'oid'}" filterEvent="onkeyup"
                                  sortOrder="#{dataTableStateHolder.sortOrders['oid']}" >
                            <ui:define name="header">OID</ui:define>
                            <h:outputText value="#{val.oid}"/>
                        </g:column>
                        <g:column filterBy="#{'name'}" sortBy="#{'name'}"
                                  sortOrder="#{dataTableStateHolder.sortOrders['name']}">
                            <ui:define name="header">Name</ui:define>
                            <h:outputText value="#{val.name}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">Available</ui:define>
                            <h:outputText rendered="#{val.available}" value="Available" styleClass="gzl-label gzl-label-green"/>
                            <h:outputText rendered="#{!val.available}" value="Not available" styleClass="gzl-label gzl-label-red"/>
                        </g:column>
                        <g:column sortBy="#{'profile'}"
                                  sortOrder="#{dataTableStateHolder.sortOrders['profile']}"
                                  filterBy="#{'profile'}" filterEvent="keyup">
                            <ui:define name="header">Profile</ui:define>
                            <h:outputText value="#{val.profile}"/>
                        </g:column>
                        <g:column sortBy="#{'descriminator'}"
                                  sortOrder="#{dataTableStateHolder.sortOrders['descriminator']}"
                                  filterBy="#{'descriminator'}" filterEvent="keyup">
                            <ui:define name="header">Descriminator</ui:define>
                            <h:outputText value="#{val.descriminator}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">Actions</ui:define>
                            <div class="gzl-never-wrap">
                                <h:outputLink value="#{fhirValidatorDescriptionList.displayValidator(val)}"
                                                 title="Access details">
                                    <gzl:span styleClass="gzl-icon-search"/>
                                </h:outputLink>
                                <h:outputLink value="#{fhirValidatorDescriptionList.editValidator(val)}"
                                                 title="Edit details" rendered="#{ssoIdentity.isLoggedIn() and ssoIdentity.hasRole('admin_role')}">
                                    <gzl:span styleClass="gzl-icon-pencil"/>
                                </h:outputLink>
                                <h:outputLink value="#{fhirValidatorDescriptionList.copyValidatorDescription(val)}"
                                                 title="Copy entry" rendered="#{ssoIdentity.isLoggedIn() and ssoIdentity.hasRole('admin_role')}">
                                    <gzl:span styleClass="gzl-icon-files-o"/>
                                </h:outputLink>
                                <a4j:commandLink actionListener="#{fhirValidatorDescriptionList.setUnavailable(val)}" render="valTable"
                                                 title="Turn entry as unavailable" rendered="#{val.available and ssoIdentity.isLoggedIn() and ssoIdentity.hasRole('admin_role')}">
                                    <gzl:span styleClass="gzl-icon-ban"/>
                                </a4j:commandLink>
                                <a4j:commandLink actionListener="#{fhirValidatorDescriptionList.setAvailable(val)}" render="valTable"
                                                 title="Turn entry as available" rendered="#{not val.available and ssoIdentity.isLoggedIn() and ssoIdentity.hasRole('admin_role')}">
                                    <gzl:span styleClass="gzl-icon-circle-green"/>
                                </a4j:commandLink>
                            </div>
                        </g:column>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="dsValTable"/>
                                <ui:param name="dataTableId" value="valTable"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                    <f:facet name="footer">
                        <gzl:div id="btnDiv" rendered="#{ssoIdentity.isLoggedIn() and ssoIdentity.hasRole('admin_role')}">

                            <h:outputLink value="#{fhirValidatorDescriptionList.newResourceValidatorDescription()}">
                                <h:commandButton type="button" value="Create a new entry (for resource validation)"
                                                 styleClass="gzl-btn-blue"/>
                            </h:outputLink>
                            <h:outputLink value="#{fhirValidatorDescriptionList.newURLValidatorDescription()}">
                                <h:commandButton type="button" value="Create a new entry (for URL validation)"
                                                 styleClass="gzl-btn-blue"/>
                            </h:outputLink>

                            <a4j:commandButton value="Reload structure definitions" styleClass="gzl-btn-orange"
                                               action="#{fhirValidatorDescriptionList.reloadStructureDefinitionsAndValueSets()}"
                                               immediate="true"/>
                        </gzl:div>
                    </f:facet>
                </gri:panel>
            </gzl:div>
        </h:form>
    </ui:define>
</ui:composition>